/* Compile with CL /AL /Gt20 reformat.c /F d6d8 */
#ifndef EGSTERN
#define EGSTERN extern
#endif
#define DOS 1
#define UNIX 2
#define HOST DOS

#ifdef _dos
#include <dos.h>
#include <conio.h>
#endif
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <math.h>
#include <ctype.h>
#include <malloc.h>

#define COEFLEN 999
#define CTRLZ 26
#define OK 1
#define BAD 0
#define MAX_SAMPLES 20000
#define MAX_LINE_LENGTH 1200
#define MAX_NO_CURVES 150
#ifndef PI
#define PI 4.0 * atan(1.0)
#endif
#ifndef TWOPI
#define TWOPI 8.0 * atan(1.0)
#endif
#ifndef min
#define min(a,b) ((a)<(b)?(a):(b))
#endif
#ifndef max
#define max(a,b) ((a)>(b)?(a):(b))
#endif
#define YES 0
#define NO 1
#define ALPHA 0.5
#define BETA 0.5
#ifndef _dos
#define huge
#endif

EGSTERN FILE *fp, *ip, *op;
EGSTERN  double start, stop, step, las_null;
EGSTERN  double huge big_temp[MAX_SAMPLES];
EGSTERN  double huge data[2][MAX_SAMPLES];
EGSTERN  char infile[80], outfile[80];
EGSTERN  int status;

char *fgetsup(char *, int, FILE *);
#ifndef _dos
#define getch getchar
#define strset(a,b) memset(a,b,sizeof(a))
#endif
void clear_screen(void);
void pause(void);
void check(void), depth(void), curve(void), reverse(void);
void resamp(void), unwrap(void), convert(void);

