#include "local.h"

void reverse() 
{ 
 int bksp, i, length;
 long file_pos, depth_pos,line;
 static char buffer[MAX_LINE_LENGTH+2];
 char type[11]; 
 char leader[80],cstart[30];
 char result[MAX_LINE_LENGTH+2];
 int strt_chk=1;

/*
   The program will; 
   - reverse depths 
 */
 
  line = 0;
  fprintf(stdout,"You have chosen to reverse the depth ordering.\n"); 
  fprintf(stdout,"Your input file %s currently has this range:\n\n",infile); 
  fprintf(stdout," STARTING DEPTH : %lf\n",start);
  fprintf(stdout,"   ENDING DEPTH : %lf\n",stop);
  fprintf(stdout,"     DEPTH STEP : %lf\n\n\n\n\n\n",step);
  fprintf(stdout,"Scanning line       ");

 
 /* Read through the file copying to the output until the depths are 
    reached. En route check for the start, stop and step values as 
    these have to be flipped.                                      */ 
 do 
 { 
  if (fgetsup(buffer,MAX_LINE_LENGTH,ip) == NULL)
  { 
   fprintf(stdout,"Cannot read from input file. Run terminated\n"); 
   return;
  } 
  else
  { 
   line++;
   for (bksp = 1; bksp < 7; bksp++)
    fprintf(stdout,"%c",8);
   fprintf(stdout,"%ld",line);
   fflush (stdout);
   strset(type,'\0');
   sscanf(buffer, "%8s", type);
 
   /* Check for start, stop and step */ 
 
   if(strncmp(type,"STRT",4) == 0 || strncmp(type,"STOP",4) == 0
      || strncmp(type,"STEP",4) == 0) 
   { 
    strset(leader,'\0');
    if(strncmp(type,"STRT",4) == 0) 
    { 
     sscanf(buffer, "%[^-1234567890]", leader); 
     fprintf(op,"%s%lf:\n",leader,stop);
    } 
 
    if(strncmp(type,"STOP",4) == 0) 
    { 
     sscanf(buffer, "%[^-1234567890]", leader);
     fprintf(op,"%s%lf:\n",leader,start);
    } 
 
    if(strncmp(type,"STEP",4) == 0) 
    { 
     sscanf(buffer, "%[^-1234567890]", leader); 
     fprintf(op,"%s%lf:\n",leader,(step * -1.0));
    } 
   } 
   else 
   {
    status=fputs(buffer,op);
    if ((status == EOF)||(status<0))
    { 
     fprintf(stdout,"Cannot write to output file. Run terminated\n");
     return;
    }
   }
  }
 }
  while (strncmp(type,"~A",2) != 0);


/* Take note of the file position at which the depths start */

  depth_pos = ftell(ip);

/* Now skip to the end of the file 
   and read the depths in reverse order */
 
 fseek(ip,0L,SEEK_END);
 file_pos = ftell(ip);

 do 
 {
   /* print line number to indicate progress */
   
  line++;
  for (bksp = 1; bksp < 7; bksp++)
  fprintf(stdout,"%c",8);
  fprintf(stdout,"%ld",line);
  fflush (stdout);
  
  /* back up 256 characters...the longest allowed line length */
  
  file_pos = file_pos - MAX_LINE_LENGTH;
  fseek (ip, file_pos, 0);
  ftell(ip);
  /* read the 256 characters and reset the file position indicator */
  buffer[0]='\0';
  fread(buffer,MAX_LINE_LENGTH,1,ip);
  ftell(ip);
  /* now parse the buffer for the last whole line it contains      */
  /* find it by scanning back for a newline and copying everything */
  /* beyond the newline to the end of the buffer into the output   */

  for (i =MAX_LINE_LENGTH; i >= 0; i--)
  {
   if(strt_chk == 1)
   if(isdigit(buffer[i]) !=0 ||(buffer[i] =='.'))
   continue;
   else
   buffer[i]='0';
   if ((buffer[i] == '0')||(buffer[i] =='.')) strt_chk=0;
   if (buffer[i] == '\n')
   {

    strncpy(result, &buffer[i+1], MAX_LINE_LENGTH+2-i);
    result[MAX_LINE_LENGTH+2-i] = '\0';


    length = strlen(result);
    if (length >9)
    {
      result[length-1] = '\n';
      fprintf(stdout,"diag: nl at %d copy from %d copy length %d\n", i, i+1, MAX_LINE_LENGTH-i);
      break;
    }
    else
	 {
	 buffer[i]=' ';
	 result[0]='\0';
	 buffer[i+1]='\0';
	 }
   }
  }
  length = strlen(result);
  file_pos = file_pos + i-1;
  fseek(ip,file_pos,0);
  ftell(ip);
  /* Make sure we didn't pick up the end of file before outputting */

  if (result[0] != 0X1A && length > 1)
  {

	if (fprintf(op, "%s", result) == 0)
	{
	fprintf(stdout,"Cannot write to output file. Run terminated\n");
	return;
	}

  }
 }
 while (file_pos > depth_pos);
 fprintf(stdout,"\nREFORMAT(DEPTH REVERSAL) COMPLETED\n");
 return;
}
