#include "local.h"
 
void curve() 
{ 
 int bksp, count,i, j, wanted[MAX_NO_CURVES], done, big_break;
 char *curve[MAX_NO_CURVES]; 
 char *temp; 
 static char buffer[MAX_LINE_LENGTH];
 char type[10]; 
 int answer;
 char number[15];
 int first;
 long line;

/* 
   The program will;
   - extract a specific curve 
 */ 

 temp = malloc(MAX_LINE_LENGTH); 
 for (i=0; i < MAX_NO_CURVES; i++) 
  curve[i] = malloc(11); 
           
 first = 1;           
 i = 0; 
 big_break = NO; 
 line = 0;
 done = 0;
 
 /* Read through the file copying to the output until the depths are
    reached. On the way check for the curve block and ask the user 
    which curves she wants.                                        */ 
 
 do 
 { 
  if (fgetsup(buffer,MAX_LINE_LENGTH,ip) == NULL)
  { 
   fprintf(stdout,"Cannot read from input file. Run terminated\n");
   return; 
  } 
  else 
  { 
   line++;
   strset(type,'\0');
   sscanf(buffer, "%8s", type);
   if (strncmp(type,"~A",2) == 0)
    break; 
 
   /* Check for ~C section         */ 

   if (strncmp(type,"~C",2) == 0)
   { 
 
   /* this is the curve selection block */ 
 
    fputs (buffer,op); 
    while (fgetsup (buffer,MAX_LINE_LENGTH,ip) != NULL) 
    { 
     line++; 
     strset(type,'\0'); 
     sscanf(buffer, "%8[^.]", type); 
     sscanf(type, "%s", type); 
     if (type[0] == '~') 
     { 
      big_break = YES; 
      break; 
     } 
 
  /* Output comments and blank lines */ 
 
     if (type[0] == '#' || strlen(type) == 0 ) 
     { 
      fputs (buffer,op); 
      continue; 
     } 
     
     if (first == 1)     /* not a comment or blank, therefore its curve 0, ie depth */
     {
          wanted[i] = 1; 
          strcpy(curve[i],type); 
          fputs(buffer,op);
          first = 0; 
          continue;
     }
       
/* Offer the user each curve until she has all she needs or there 
   are none left. Clear the screen between choices to reduce clutter */ 
 
bad_reply: ; 

     clear_screen(); 
     fprintf(stdout,"You have chosen to extract a specific curve.\n"); 
     fprintf(stdout,"Your input file %s has this depth range:\n\n",infile); 
     fprintf(stdout," STARTING DEPTH : %lf\n",start);
     fprintf(stdout,"   ENDING DEPTH : %lf\n",stop);
     fprintf(stdout,"     DEPTH STEP : %lf\n\n\n\n\n\n",step);
     i++; 
 
 
     if (done != 1) 
     { 
      fprintf(stdout,"Do you want to include this curve ?\n"); 
      fprintf(stdout,"%s\n",type); 
      fprintf(stdout,"Please type Y for yes, N for no, Q for no more curves:"); 
      /* fflush(stdin); */
      fflush(stdout);
      answer = getch();
 
/* Store the index of the required curves in an array.  */ 
 
     switch (answer) 
     { 
      case 'Q': 
      case 'q':
          wanted[i] = 9; 
          done = 1; 
          do 
          { 
      fgetsup (buffer,MAX_LINE_LENGTH,ip); 
      line++; 
      strset(type,'\0'); 
      sscanf(buffer, "%8s", type); 
          } while (type[0] != '~'); 
          big_break = YES; 
          break; 
      case 'N': 
      case 'n':
	  wanted[i] = 0;
	  break;
      case 'Y': 
      case 'y':
          wanted[i] = 1; 
          strcpy(curve[i],type); 
          fputs(buffer,op); 
          break; 
      default: 
          i--;
          clear_screen();
          goto bad_reply; 
     } 
     if (big_break == YES) 
      break; 
    }                      /* end of while loop   */ 
    }                      /* end of while loop   */ 
    clear_screen(); 
    fprintf(stdout,"Curve selection complete.  Outputting data values...\n");
    fprintf(stdout,"Scanning line      \n");
 
   }                       /* end of curves block */ 
 
   if (strncmp(type,"~A",2) != 0) 
   {
    status=fputs(buffer,op);
    if ((status == EOF)||(status<0))
    {
     fprintf(stdout,"Cannot write to output file. Run terminated\n");
     return; 
    } 
   } 
  } 
 } while (strncmp(type,"~A",2) != 0); 
 
  /* We now have to reconstruct the ~A line. */ 
 
 fprintf(op, "~A    DEPTH"); 
 for (j = 1; j <= i && wanted[j] != 9; j++) 
 {
  if (wanted[j] == 1) 
   fprintf(op, "%11s",curve[j]); 
 } 
 fprintf(op, "\n");

  /* Now output the values for the selected curves  */ 

 while (fgets(buffer,MAX_LINE_LENGTH,ip) != NULL) 
 {
  line++;
  for (bksp = 1; bksp < 7; bksp++)
   fprintf(stdout,"%c",8);
  fprintf(stdout,"%ld",line);
  fflush(stdout);
  count = 0;
  while((sscanf(buffer,"%s",number)) == 1)
  { 
   temp = strstr(buffer,number);
   strcpy(buffer,temp+strlen(number));
   if(wanted[count] == 1)
    fprintf(op,"%11s",number);
   if(wanted[count] == 9)
    break; 
    count++;
  } 
  fprintf(op,"     \n");

 } 
 fprintf(stdout,"\nREFORMAT(CURVE SELECTION) COMPLETED\n"); 
}
